"use strict";
this.name	= "lasercannons";
this.author	= "Norby";
this.copyright	= "2015 Norby";
this.description= "Combat-capable Mining lasers";
this.licence	= "CC BY-NC-SA 4.0";

//worldscript events
this.startUp = function() {
	this.$Towbar = worldScripts.towbar;
}

this.shipAttackedOther = function(other) { //player hits other
	if(!other || !other.isValid || other.isPlayer || !player.ship || !player.ship.isValid )
		return; //exit if the target is died or player (for sure)
	var c = player.ship.currentWeapon, cw = "";
	if( c ) cw = c.equipmentKey;
	if( !other.isDerelict && !other.isThargoid && cw.indexOf("EQ_WEAPON_CANNON_") > -1 ) {
		//the next cannon hit can destroy the target
		var rnd = Math.random();
		//eject when less than 64 energy left and hit by any cannon
		if( other.energy < 64 && other.energy > 0 ||
			( ( cw == "EQ_WEAPON_CANNON_8" || cw == "EQ_WEAPON_CANNON_10" )
				//Plasma Ray and Plasma Vulcan critical hit 5% chance
				&& ( other.energy < 30 || rnd < 0.05 ) ) ||
			//eject when less than 60 energy left and hit by Plasma Web
			(  cw == "EQ_WEAPON_CANNON_9" //Plasma Web critical hit 20% chance
				&& ( other.energy < 60 || rnd < 0.2 ) ) ) {

			if( rnd < 0.5 ) other.awardEquipment("EQ_ESCAPE_POD"); //more Pod in Plasma era

			other.fireMissile();//last resort
			if( other.equipmentStatus("EQ_ESCAPE_POD") === "EQUIPMENT_OK"
				&& other.abandonShip()) {//eject only if has Escape Pod 
				if( worldScripts["detectors"] ) {
					var dn = other.script.$Detectors_Origname;//short name with version
				} else {
					var dn = other.displayName;
					other.displayName = "Derelict " + other.displayName;
				}
				player.consoleMessage(dn+" ejected!");
				if( other.script && !other.script.$AlreadyScored ) {
					other.script.$AlreadyScored = true;
					player.score++;
				}
			} else if( other.energy > 1 ) other.energy = 1; //critical hit without escape pod
		}
	}
	if( other.isDerelict && !other.isThargoid ) {
		player.consoleMessage("Derelict!", 10); //warn to stop fire if want to salvage it
		if( player.ship.equipmentStatus("EQ_LASERREDUCTOR") == "EQUIPMENT_OK"
			&& cw.indexOf("EQ_WEAPON_CANNON_") > -1 
			&& other.energy < 200 && other.energy < other.maxEnergy
			&& ( !this.$Towbar || ( this.$Towbar.$TowbarLaserReductorOn && other.script
				&& other.script.$TowbarDerelictAttack <= this.$Towbar.$TowbarMaxReduct ) ) ) {
			other.energy = Math.min(other.maxEnergy, 200); //reduce cannon power
		}
	}
	this.$Bounty( other );
}

this.shipTakingDamage = function(amount, whom, type ) {
	log(this.name, type); //debug
	if(!whom || !whom.isValid || whom.isPlayer || !player.ship || !player.ship.isValid
		|| amount == 0 ) return; //exit if the target is died or player (for sure) or shield hit only
	var c = whom.currentWeapon, cw = "";
	if( c ) cw = c.equipmentKey;
	if( ( cw == "EQ_WEAPON_CANNON_8" || cw == "EQ_WEAPON_CANNON_10" )
			//Plasma Ray and Plasma Vulcan critical hit 5% chance
			&& ( player.ship.energy < 30 || Math.random() < 0.05 )
		|| cw == "EQ_WEAPON_CANNON_9" //Plasma Web critical hit 20% chance
			&& ( player.ship.energy < 60 || Math.random() < 0.2 ) ) {
		if( player.ship.equipmentStatus("EQ_ESCAPE_POD") === "EQUIPMENT_OK"
			&& player.ship.abandonShip()) {//eject only if has Escape Pod
			player.consoleMessage("Critical plasma hit on your ship, auto eject!", 10);
		} else {
			player.consoleMessage("Critical plasma hit on your ship!", 10);
			if( player.ship.energy > 1 ) player.ship.energy = 1; //critical hit without escape pod
		}
	} else if( cw == "EQ_WEAPON_CANNON_8" || cw == "EQ_WEAPON_CANNON_9" || cw == "EQ_WEAPON_CANNON_10" ) {
		player.consoleMessage("Plasma hit on your ship, go away to avoid a critical hit!", 10);
	} else if( cw.indexOf("EQ_WEAPON_CANNON_") > -1 && player.ship.energy < 64 ) {
		if( player.ship.equipmentStatus("EQ_ESCAPE_POD") === "EQUIPMENT_OK"
			&& player.ship.abandonShip()) {//eject only if has Escape Pod 
			player.consoleMessage("Cannon hit on your ship and energy is low, auto eject!", 10);
		} else player.consoleMessage("Cannon hit on your ship and energy is low!", 10);
	}
}

this.$Bounty = function( ship ) {
	if( ship.isDerelict && ship.bounty > 0 ) {
		player.credits += ship.bounty;
		player.consoleMessage("Bounty: "+formatCredits(ship.bounty, true, true));
		player.consoleMessage("Total: "+formatCredits(player.credits, true, true));
		if( ship.script ) ship.script.$TowbarBounty = ship.bounty;//save to Towbar award illegal cargo
		ship.bounty = 0;
		if( !this.$Towbar && Math.random() < 0.2 )
			ship.explode(); //imitate a bomb added in Towbar
	}
}

